<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>

<%@ page import="org.wso2.carbon.mediator.aggregate.AggregateMediator" %>
<%@ page import="org.wso2.carbon.mediator.service.ui.Mediator" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.ns.XPathFactory" %>

<%
    Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
    if (!(mediator instanceof AggregateMediator)) {
        // todo : proper error handling
        throw new RuntimeException("Unable to edit the mediator");
    }
    String aggregate_expr = request.getParameter("aggregate_expr");
    String complete_time = request.getParameter("complete_time");
    String complete_max = request.getParameter("complete_max");
    String complete_min = request.getParameter("complete_min");
    String correlate_exp = request.getParameter("correlate_expr");
    String sequenceOption = request.getParameter("sequenceOption");

    AggregateMediator aggregateMediator = (AggregateMediator) mediator;
    if(!complete_max.equals("")){
        aggregateMediator.setMaxMessagesToComplete(Integer.parseInt(complete_max));
    } else {
        aggregateMediator.setMaxMessagesToComplete(-1);
    }
    if(!complete_min.equals("")){
        aggregateMediator.setMinMessagesToComplete(Integer.parseInt(complete_min));
    } else {
        aggregateMediator.setMinMessagesToComplete(-1);
    }
    if ("selectFromRegistry".equals(sequenceOption)) {
        String selectFromRegistry = request.getParameter("mediator.sequence");
        aggregateMediator.setOnCompleteSequenceRef(selectFromRegistry);
        int size = aggregateMediator.getList().size();
        for (int i = 0; i < size; i++) {
            aggregateMediator.removeChild(i);                   
        }
    } else {
        aggregateMediator.setOnCompleteSequenceRef(null);
    }
    if(!complete_time.equals("")){
        long value = Long.parseLong(complete_time);
        aggregateMediator.setCompletionTimeoutSec(value);
    } else {
        aggregateMediator.setCompletionTimeoutSec(0);
    }

     XPathFactory xPathFactory = XPathFactory.getInstance();
      if(!aggregate_expr.equals("")){
            aggregateMediator.setAggregationExpression(xPathFactory.createSynapseXPath("aggregate_expr", request, session));
      }
      if(!correlate_exp.equals("")){
            aggregateMediator.setCorrelateExpression(xPathFactory.createSynapseXPath("correlate_expr", request, session));
      } else {
            aggregateMediator.setCorrelateExpression(null);
      }
      
      if (request.getParameter("mediator.aggregate.id") != null && 
    				  !request.getParameter("mediator.aggregate.id").trim().
						equals("")) {
    		aggregateMediator.setId(request.getParameter("mediator.aggregate.id"));
	  }
%>

