/*
 *  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

function isValidKey(keyemptymsg) {
    var nsCount = document.getElementById("keyCount");
    var i = nsCount.value;
    var currentCount = parseInt(i);
    //currentCount = currentCount + 1;
    if (currentCount > 0) {
        for (var k = 0; k < currentCount; k++) {
            var prefix = document.getElementById("keyValue" + k);
            if (prefix != null && prefix != undefined) {
                if (prefix.value == "") {
                    CARBON.showWarningDialog(keyemptymsg)
                    return false;
                }
            }
        }
    }
    return true;
}

function isValidFeatures(nameemptymsg) {
    var nsCount = document.getElementById("featureCount");
    var i = nsCount.value;
    var currentCount = parseInt(i);
    if (currentCount >= 1) {
        for (var k = 0; k < currentCount; k++) {
            var prefix = document.getElementById("featureName" + k);
            if (prefix != null && prefix != undefined) {
                if (prefix.value == "") {
                    CARBON.showWarningDialog(nameemptymsg)
                    return false;
                }
            }
        }
    }
    return true;
}

function addfeature(nameempty) {
    if (!isValidFeatures(nameempty)) {
        return false;
    }
    var featureCount = document.getElementById("featureCount");
    var i = featureCount.value;
    var currentCount = parseInt(i);
    currentCount = currentCount + 1;

    featureCount.value = currentCount;

    var featureTable = document.getElementById("featuretable");
    featureTable.style.display = "";
    var featuretbody = document.getElementById("featuretbody");

    var featureRaw = document.createElement("tr");
    featureRaw.setAttribute("id", "featureRaw" + i);

    var nameTD = document.createElement("td");
    nameTD.appendChild(createinputtextbox("featureName" + i), "");

    var valueTD = document.createElement("td");
    valueTD.appendChild(createboolselectelement("featureValue" + i));

    var deleteTD = document.createElement("td");
    deleteTD.innerHTML = "<a href='#' class='delete-icon-link' onclick='deletefeature(" + i + ");return false;'>Delete</a>";

    featureRaw.appendChild(nameTD);
    featureRaw.appendChild(valueTD)
    featureRaw.appendChild(deleteTD);

    featuretbody.appendChild(featureRaw);
    return true;
}

function createinputtextbox(id, value) {

    var input = document.createElement('input');
    input.setAttribute('id', id);
    input.name = id;
    input.setAttribute('type', 'text');
    if (value != null && value != undefined) {
        input.setAttribute('value', value);
    }

    return input;
}

function deletefeature(i) {
    CARBON.showConfirmationDialog(validate18n["mediator.validate.delete.confirm"],function(){
    var featureRow = document.getElementById("featureRaw" + i);
    if (featureRow != undefined && featureRow != null) {
        var parentTBody = featureRow.parentNode;
        if (parentTBody != undefined && parentTBody != null) {
            parentTBody.removeChild(featureRow);
            if (!isContainRaw(parentTBody)) {
                var featureTable = document.getElementById("featuretable");
                featureTable.style.display = "none";
            }
        }
    }
    });
}

function deleteKey(i) {
    CARBON.showConfirmationDialog(validate18n["mediator.validate.delete.confirm"],function(){
    var propRow = document.getElementById("keyRaw" + i);
    if (propRow != undefined && propRow != null) {
        var parentTBody = propRow.parentNode;
        if (parentTBody != undefined && parentTBody != null) {
            parentTBody.removeChild(propRow);
            if (!isContainRaw(parentTBody)) {
                var propertyTable = document.getElementById("keytable");
                propertyTable.style.display = "none";
            }
        }
    }
    });
}

function isContainRaw(tbody) {
    if (tbody.childNodes == null || tbody.childNodes.length == 0) {
        return false;
    } else {
        for (var i = 0; i < tbody.childNodes.length; i++) {
            var child = tbody.childNodes[i];
            if (child != undefined && child != null) {
                if (child.nodeName == "tr" || child.nodeName == "TR") {
                    return true;
                }
            }
        }
    }
    return false;
}

function validateMediatorValidate() {
    var nameemptymsg = validate18n["mediator.validate.feature.name.empty"];
    var keyemptymsg = validate18n["mediator.validate.schema.key.empty"];

    var nsCount = document.getElementById("keyCount");
    var i = nsCount.value;
    currentCount = parseInt(i);
    if (currentCount >= 0) {
        for (var k = 0; k <= currentCount; k++) {
            var prefix = document.getElementById("keyValue" + k);
            if (prefix != null && prefix != undefined) {
                if (prefix.value == "") {
                    CARBON.showWarningDialog(keyemptymsg)
                    return false;
                }
            }
        }
    }

    nsCount = document.getElementById("featureCount");
    i = nsCount.value;
    currentCount = parseInt(i);
    if (currentCount >= 1) {
        for (k = 0; k < currentCount; k++) {
            prefix = document.getElementById("featureName" + k);
            if (prefix != null && prefix != undefined) {
                if (prefix.value == "") {
                    CARBON.showWarningDialog(nameemptymsg)
                    return false;
                }
            }
        }
    }
    return true;
}

function createboolselectelement(id) {
    // Create the element:
    var combo_box = document.createElement('select');

    // Set some properties:
    combo_box.name = id;
    combo_box.setAttribute("id", id);

    // Add some choices:
    var choice = document.createElement('option');
    choice.value = 'true';
    choice.appendChild(document.createTextNode(validate18n["mediator.validator.true"]));
    combo_box.appendChild(choice);

    choice = document.createElement('option');
    choice.value = 'false';
    choice.appendChild(document.createTextNode(validate18n["mediator.validator.false"]));
    combo_box.appendChild(choice);

    return combo_box;
}



function onKeyTypeSelectionChange(i, name) {
    var keyType = getSelectedValue('keyTypeSelection' + i);
    if (keyType != null) {
       settype(keyType, i, name);
    }

}

function settype(type, i, name) {

    var nsEditorButtonTD = document.getElementById("nsEditorButtonTD" + i);
    var regBrowserTD = document.getElementById("regBrowserTD" + i);

    var keyValue = document.getElementById("keyValue" + i);

    if ((nsEditorButtonTD == null || nsEditorButtonTD == undefined) && (regBrowserTD == null || regBrowserTD == undefined)) {
        return;
    }
    if ("dynamic" == type) {
        //resetDisplayStyle("");
        keyValue.readOnly = false;
        if (nsEditorButtonTD != undefined && nsEditorButtonTD != null) {
            nsEditorButtonTD.style.display = "";
            regBrowserTD.style.display = 'none';
        }
        nsEditorButtonTD.innerHTML = "<a href='#nsEditorLink' class='nseditor-icon-link' style='padding-left:40px' onclick=\"showNameSpaceEditor('keyValue" + i + "')\">" + name + "</a>";
        regBrowserTD.innerHTML = "";

    } else {
        keyValue.readOnly = true;
        nsEditorButtonTD.innerHTML = "";
        regBrowserTD.innerHTML = "<a href='#registryBrowserLink'  class='registry-picker-icon-link' " +
                                 "onclick=\"showRegistryBrowser('keyValue" + i + "','/_system/config'" + ")\">Configuration Registry</a>" +
                                 "<a href='#registryBrowserLink'  class='registry-picker-icon-link' " +
                                 "onclick=\"showRegistryBrowser('keyValue" + i + "','/_system/governance'" + ")\">Governance Registry</a>";

        if (regBrowserTD != undefined && regBrowserTD != null) {
            regBrowserTD.style.display = "";
            nsEditorButtonTD.style.display = 'none';
        }
    }
}

function addNewKey(keyEmptyMsg) {

    if (!isValidKey(keyEmptyMsg)) {
        return false;
   }

    var keyCount = document.getElementById("keyCount");
    var i = keyCount.value;

    var currentCount = parseInt(i);
    currentCount = currentCount + 1;

    keyCount.value = currentCount;

    var keyTable = document.getElementById("keyTable");
    keyTable.style.display = "";
    var keyTableBody = document.getElementById("keyTableBody");

    var keyRaw = document.createElement("tr");
    keyRaw.setAttribute("id", "keyRaw" + i);

    var typeTD = document.createElement("td");
    typeTD.appendChild(createKeyTypeComboBox('keyTypeSelection' + i, i, name))

    var valueTD = document.createElement("td");
    valueTD.innerHTML = "<input type='text' name='keyValue" + i + "' id='keyValue" + i + "' value='' readonly='true'/>";

    var nsTD = document.createElement("td");
    nsTD.setAttribute("id", "nsEditorButtonTD" + i);
    nsTD.style.display = 'none';

    var regBrowserTD = document.createElement("td");
    regBrowserTD.setAttribute("id", "regBrowserTD" + i);
    regBrowserTD.style.display = "";
    regBrowserTD.innerHTML = "<a href='#registryBrowserLink'  class='registry-picker-icon-link' " +
                             "onclick=\"showRegistryBrowser('keyValue" + i + "','/_system/config'" + ")\">Configuration Registry</a>" +
                             "<a href='#registryBrowserLink'  class='registry-picker-icon-link' " +
                             "onclick=\"showRegistryBrowser('keyValue" + i + "','/_system/governance'" + ")\">Governance Registry</a>";


    var deleteTD = document.createElement("td");
    //deleteTD.innerHTML = "<a href='#' class='delete-icon-link' onclick='deleteKey(" + i + ")' >" + validate18n["mediator.validate.action.delete"] + "</a>";
    deleteTD.innerHTML = "<a href='#' class='delete-icon-link' onclick='deleteKey(" + i + ");return false;'>" + validate18n["mediator.validate.action.delete"] + "</a>";
    // propertyRaw.appendChild(nameTD);
    keyRaw.appendChild(typeTD);
    keyRaw.appendChild(valueTD);
    keyRaw.appendChild(nsTD);
    keyRaw.appendChild(regBrowserTD);
    keyRaw.appendChild(deleteTD);

    keyTableBody.appendChild(keyRaw);
    return true;
}

function createKeyTypeComboBox(id, i, name) {
    // Create the element:
    var combo_box = document.createElement('select');

    // Set some properties:
    combo_box.name = id;
    combo_box.setAttribute("id", id);
    combo_box.onchange = function () {
        onKeyTypeSelectionChange(i, name)
    };
    // Add some choices:
    var choice = document.createElement('option');
    choice.value = 'static';
    choice.appendChild(document.createTextNode(validate18n["mediator.validate.text.value"]));
    combo_box.appendChild(choice);

    choice = document.createElement('option');
    choice.value = 'dynamic';
    choice.appendChild(document.createTextNode(validate18n["mediator.validate.text.expression"]));
    combo_box.appendChild(choice);

    return combo_box;
}

function getSelectedValue(id) {
    var propertyType = document.getElementById(id);
    var propertyType_indexstr = null;
    var propertyType_value = null;
    if (propertyType != null) {
        propertyType_indexstr = propertyType.selectedIndex;
        if (propertyType_indexstr != null) {
            propertyType_value = propertyType.options[propertyType_indexstr].value;
            //alert("propertyType_value = " + propertyType_value);
        }
    }
    return propertyType_value;
}